<?php

// +---------------------------------------------------------------------------+
// | DBView 1.1 for Geeklog - The Ultimate Weblog                              |
// +---------------------------------------------------------------------------+
// | dbview.php                                                                |
// |                                                                           |
// | This file is the dbview for Geeklog.                                      |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2002 by the following authors:                              |
// |                                                                           |
// | Authors: Tom Willett        - tomw@pigstye.net                            |
// |                                                                           |
// | Modified by Cameron Hayne (hayne@sympatico.ca), Nov 4, 2002               |
// | to show the results of 'describe'                                         |
// | and to have the "View" button on each page                                |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../lib-common.php');

// Only let Root users access this page
if (!SEC_inGroup('Root')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the DBview page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock("Access Denied!!!");
    $display .= "You are illegally trying to access the DBview administration page.  This attempt has been logged";
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}

/**
* Get the field names for a recordset     
*  
* This function takes a recordset and returns an array of the field names            
*
* @param    object  $recordset  Recordset                         
* @return   array   Returns a multidimensional array of the table names and information
*                   array['fieldname']['attribute'] where attribute can be: blob, max_length,
*					multiple_key, name, numeric, primary_key, table, type, unique_key, unsigned,
*					zerofill.  All the values are either strings, numbers or 1 or 0 for true, false.
*/
function getFieldInfo($recordset) {
    $numfields = mysql_num_fields($recordset);
    $retval = array ();        
    for ($i = 0; $i < $numfields; $i++) {
    	$meta = mysql_fetch_field($recordset);
    	if ($meta) {
    		$name = $meta->name;
	        $retval["$name"]=$meta;
	    }                   
    }                    
    return $retval;
}

/* 
* Main Function
*/

$display = COM_siteHeader();

$display .= COM_startBlock("DBView -- View Geeklog Database Structure");
COM_errorLog("Someone has accessed the DBview page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
$display .= "<form method='post' action='" . $_CONF['site_admin_url'] . "/dbview.php'>";
$display .= "<table><tr><td>";
$RECS = mysql_list_tables($_DB_name);
while ($A=mysql_fetch_row($RECS)) {
	$tables[]=$A[0];
}
mysql_free_result($RECS);
$display .= '<SELECT name="table">';
if (empty($table)) { $table = $tables[0]; } // default table to show 
for ($i = 0; $i < count($tables); $i++) {
	$display .= '<option value="' . $tables[key($tables)] . '"';
	if ($table == $tables[$i]) { $display .= ' SELECTED'; }
	$display .= '>' . $tables[key($tables)] . '</option>';
    next($tables);
}
$display .= "</SELECT></td><td align='left'>";
$display .= "<input type='submit' name='action' value='View'>";
$display .= "<input type='hidden' name='page' value='1'>";
$display .= '</td></tr></table></form>';

//CH
$result=DB_query("Describe $table");
$display .= '<H2>Table: ' . $table . '</H2>';
$display .= '<table border=1 rules=all cellpadding=3>';
$display .= '<tr>'
		. '<th>Field</th><th>Type</th><th>Null</th>'
		. '<th>Key</th><th>Default</th><th>Extra</th>'
		. '</tr>';
while ($row = DB_fetchArray($result))
{
	$display .= '<tr>';
	for ($i = 0; $i < 6; $i++)
	{
		$display .= '<td>'
				. ($row[$i] ? $row[$i] : "&nbsp;")
				. '</td>';
	}
	$display .= '</tr>';
}
$display .= '</table><hr>';
//. . . CH

$result=DB_query("Select * from $table");
$fieldinfo=getFieldInfo($result);
foreach($fieldinfo as $name => $meta) {
	$display .= "Information for column $name:<br />\n";
    $display .= "<pre>
        blob:         $meta->blob
        max_length:   $meta->max_length
        multiple_key: $meta->multiple_key
        name:         $meta->name
        not_null:     $meta->not_null
        numeric:      $meta->numeric
        primary_key:  $meta->primary_key
        table:        $meta->table
        type:         $meta->type
        unique_key:   $meta->unique_key
        unsigned:     $meta->unsigned
        zerofill:     $meta->zerofill
        </pre>";
}

$display .= COM_endBlock();                                
$display .= COM_siteFooter(true);
echo $display;
?>
